// BDialog.cpp : implementation file
//

#include "stdafx.h"
#include "dibapi.h"
#include "BDialog.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBDialog dialog


CBDialog::CBDialog(UINT nIDTemplate, CWnd* pParent /*=NULL*/)
	: CDialog(nIDTemplate, pParent)
{
	//{{AFX_DATA_INIT(CBDialog)
		// NOTE: the ClassWizard will add member initialization here
		m_style=StyleStretch;
		m_pbitmap = NULL;
		pHDIB = NULL;
	//}}AFX_DATA_INIT
}

CBDialog::~CBDialog()
{
	if (pHDIB)
		free(pHDIB);
}

BEGIN_MESSAGE_MAP(CBDialog, CDialog)
	//{{AFX_MSG_MAP(CBDialog)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBDialog message handlers

BOOL CBDialog::OnEraseBkgnd(CDC* pDC) 
{
	int newpalette = 0;

	CDialog::OnEraseBkgnd(pDC);	
	if (!m_pbitmap) {		
		if (pHDIB) {
			LPSTR lpDIB = (LPSTR)pHDIB;
			int cxDIB = (int) ::DIBWidth(lpDIB);         // Size of DIB - x
			int cyDIB = (int) ::DIBHeight(lpDIB);        // Size of DIB - y

			LPSTR s = FindDIBBits(lpDIB);
			m_bitmap.DeleteObject();
			m_bitmap.CreateCompatibleBitmap(pDC, cxDIB, cyDIB);
			int passo = WIDTHROW(cxDIB);
			LPSTR m = (LPSTR)malloc(passo*cyDIB*4);

			if (::DIBHeightSign(lpDIB) > 0) { 
				for (int y = 0; y < cyDIB ; y++) {
					for (int x = 0; x < cxDIB; x++) {
						m[(y*cxDIB+x)*4] = s[((cyDIB - y - 1)*passo+x)];
						m[(y*cxDIB+x)*4+1] = s[((cyDIB - y - 1)*passo+x)];
						m[(y*cxDIB+x)*4+2] = s[((cyDIB - y - 1)*passo+x)];
						m[(y*cxDIB+x)*4+3] = 0;
					}
				}
			} else {
				for (int y = 0; y < cyDIB ; y++) {
					for (int x = 0; x < cxDIB; x++) {
						m[(y*cxDIB+x)*4] = s[y*passo+x];
						m[(y*cxDIB+x)*4+1] = s[y*passo+x];
						m[(y*cxDIB+x)*4+2] = s[y*passo+x];
						m[(y*cxDIB+x)*4+3] = 0;
					}
				}
			}
			m_bitmap.SetBitmapBits(cxDIB*cyDIB*4, m);
			m_pbitmap = &m_bitmap;
			m_palDIB = new CPalette;
			if (m_palDIB == NULL) {
				// we must be really low on memory
				return false;
			}
			if (::CreateDIBPalette(pHDIB, m_palDIB) == NULL) {
				// DIB may not have a palette
				delete m_palDIB;
				m_palDIB = NULL;
				return false;
			}
			newpalette = 1;
			//free(pHDIB);
			pHDIB = NULL;
			free(m);
		} else 
			return false;
	}

	CRect rect;
	GetClientRect(&rect);
	CDC dc;
	dc.CreateCompatibleDC(pDC);
	CBitmap* pOldBitmap = dc.SelectObject(m_pbitmap);	
	if (newpalette) {
		dc.SelectPalette(m_palDIB, TRUE); 
		delete m_palDIB;
	}
	int bmw, bmh ;
	BITMAP bmap;
	m_pbitmap->GetBitmap(&bmap);
	bmw = bmap.bmWidth;
	bmh = bmap.bmHeight;
	int xo=0, yo=0;
	if(m_style == StyleTile) {
		for (yo = 0; yo < rect.Height(); yo += bmh) {
			for (xo = 0; xo < rect.Width(); xo += bmw) {
				pDC->BitBlt (xo, yo, rect.Width(),
					rect.Height(), &dc,
					0, 0, SRCCOPY);
			}
		}
	}

	if(m_style == StyleCenter) {
		if(bmw < rect.Width())
			xo = (rect.Width() - bmw)/2;
		else 
			xo = 0;
		if(bmh < rect.Height())
			yo = (rect.Height()-bmh)/2;
		else
			yo=0;
		pDC->BitBlt (xo, yo, rect.Width(),
			rect.Height(), &dc,
			0, 0, SRCCOPY);
	}

	if(m_style == StyleStretch) {
		pDC->StretchBlt(xo, yo, rect.Width(),
			rect.Width() * bmh/bmw, &dc,
			0, 0,bmw, bmh, SRCCOPY);
	}

	//dc.SelectObject(pOldBitmap);

	return true;
}

void CBDialog::SetBitmapStyle(int style)
{
	if((style==StyleTile)||
		(style==StyleCenter)||
		(style==StyleStretch))
	{	
		m_style = style;
	}

}

int CBDialog::SetBitmap(UINT nIDResource)
{
	if (m_bitmap.LoadBitmap(nIDResource)) {
		m_pbitmap = &m_bitmap;
		pHDIB = NULL;
		return 0;
	} else
		return 1;//error
}

int CBDialog::LoadBitmapfromDIB(HDIB hDIB)
{
	if (pHDIB) {
		m_bitmap.DeleteObject();
		free(pHDIB);
	}
	m_pbitmap = NULL;
	pHDIB = hDIB;
	return 0;
}
