// Display_IMG.cpp : implementation file
//

#include "stdafx.h"
#include "Example.h"
#include "Display_IMG.h"

CPen	ColorAxis(PS_SOLID, 1, RGB(115, 100, 249));
CPen	ColorBorder(PS_DOT, 1, RGB(115, 100, 249));
CPen	ColRefL(PS_SOLID, 1, RGB(0, 255, 255));
CPen	ColRefR(PS_SOLID, 1, RGB(0, 255, 0));
CPen	ColMark(PS_SOLID, 1, RGB(190, 190, 190));
CPen	ColorNewW(PS_SOLID, 1, RGB(115, 100, 249));
CPen	ColorRED(PS_SOLID, 1, RGB(0, 255, 0));
CPen	ColorBLU(PS_SOLID, 1, RGB(0, 0, 255));

// Display_IMG dialog
IMPLEMENT_DYNAMIC(Display_IMG, CDialog)

Display_IMG::Display_IMG(CWnd* pParent /*=NULL*/)
	: CBDialog(Display_IMG::IDD, pParent)
{
	hDIB = NULL;
	m_palDIB = NULL;
	LMouseDown = 0;
}

Display_IMG::~Display_IMG()
{
	if (m_palDIB != NULL) {
		delete m_palDIB;
		m_palDIB = NULL;
	}
}

BOOL Display_IMG::OnInitDialog()
{
	ICurs.x = ICurs.y = 0;
	FCurs.x = FCurs.y = 0;
	return TRUE;
}

void Display_IMG::DoDataExchange(CDataExchange* pDX)
{
	CBDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(Display_IMG, CBDialog)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_CLOSE()
END_MESSAGE_MAP()

void Display_IMG::PostNcDestroy()
{
    CDialog::PostNcDestroy();
    //delete this;
}
void Display_IMG::OnClose()
{
    CDialog::OnClose();
    DestroyWindow();
}

void Display_IMG::OnDraw(CDC *pDC)
{
	if (hDIB != NULL)
	{
		LPSTR lpDIB = (LPSTR)hDIB;
		int cxDIB = (int) ::DIBWidth(lpDIB);         // Size of DIB - x
		int cyDIB = (int) ::DIBHeight(lpDIB);        // Size of DIB - y
		CRect rcDIB;
		rcDIB.top = rcDIB.left = 0;
		rcDIB.right = cxDIB;
		rcDIB.bottom = cyDIB;
		CRect rcDest;
		rcDest = rcDIB;
		::PaintDIB(pDC->m_hDC, &rcDest, hDIB, &rcDIB, m_palDIB);
	}
}

BOOL Display_IMG::loadDIB(HDIB pDIB)
{
	if (m_palDIB != NULL) {
		delete m_palDIB;
		m_palDIB = NULL;
	}
	if (pDIB == NULL) {
		return FALSE;
	}
	hDIB = pDIB;
	// Set up document size
	LPSTR lpDIB = (LPSTR)hDIB;
	if (::DIBWidth(lpDIB) > INT_MAX || ::DIBHeight(lpDIB) > INT_MAX) {
		CString strMsg;
		MessageBox(_T("File too big"), NULL, MB_ICONINFORMATION | MB_OK);
		return FALSE;
	}
	m_sizeDoc = CSize((int) ::DIBWidth(lpDIB), (int) ::DIBHeight(lpDIB));
	// Create copy of palette
	m_palDIB = new CPalette;
	if (m_palDIB == NULL) {
		// we must be really low on memory
		return FALSE;
	}
	if (::CreateDIBPalette(hDIB, m_palDIB) == NULL) {
		// DIB may not have a palette
		delete m_palDIB;
		m_palDIB = NULL;
		return FALSE;
	}
	Image_DimX = ::DIBWidth(lpDIB);
	Image_DimY = ::DIBHeight(lpDIB);
	RECT wa, cb;
	// Stupid Microsoft inconsistency!!!!
	// the point is inside the client Area while the draw is in the window area!
	// All this code for nothing!
	Display_IMG::GetWindowRect(&wa);
	Display_IMG::GetClientRect(&cb);
	int Left_width = (abs(wa.right - wa.left) - cb.right) / 2;
	int Header_Hight = abs(wa.bottom - wa.top) - cb.bottom - Left_width;

	// Resize the window to the size of the image 
	CRect a;
	SystemParametersInfo(SPI_GETWORKAREA, 0, &a, 0);
	int sizex = ::DIBWidth(lpDIB)+Left_width;
	if (a.Width() < sizex) sizex = a.Width();
	int sizey = ::DIBHeight(lpDIB)+Header_Hight;
	if (a.Height() < sizey) sizey = a.Height();
	::SetWindowPos(m_hWnd, HWND_TOP, (a.Width() - sizex) / 2, (a.Height() - sizey) / 2, sizex, sizey, SWP_SHOWWINDOW);
	Display_IMG::GetClientRect(&cb);
	Dialog_DimX = cb.right;
	Dialog_DimY = cb.bottom;
	Image_PixelxMeterX = ::DIBPixelxMeterX(lpDIB);
	Image_PixelxMeterY = ::DIBPixelxMeterY(lpDIB);
	return TRUE;
}

void Display_IMG::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
	Dialog_DimX = cx;
	Dialog_DimY = cy;
	ICurs.x = ICurs.y = 0;
	FCurs.x = FCurs.y = 0;
	this->Invalidate(1);
}

void Display_IMG::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (!LMouseDown) {
		if (!(ICurs.x == 0 && ICurs.y == 0 &&	FCurs.x == 0 && FCurs.y == 0))
			DrawSelectedRectangle(ICurs, FCurs, 0);
		ICurs.x = point.x;
		ICurs.y = point.y;
		OLDICurs = ICurs;
		OLDFCurs = ICurs;
		LMouseDown = 1;
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void Display_IMG::DrawSelectedRectangle(CPoint IPos, CPoint FPos, int redraw)
{
	CDC	*pDC;
	RECT a, b;

	pDC = GetWindowDC();
	// Stupid Microsoft inconsistency!!!!
	// the point is inside the client Area while the draw is in the window area!
	// All this code for nothing!
	Display_IMG::GetWindowRect(&a);
	Display_IMG::GetClientRect(&b);
	int Left_width = (abs(a.right - a.left) - b.right) / 2;
	int Header_Hight = abs(a.bottom - a.top) - b.bottom - Left_width;

	CPen *oldpen = pDC->SelectObject(&ColorAxis);
	pDC->SetROP2(R2_XORPEN);
	pDC->SelectObject(&ColRefL);
	// Erase old
	pDC->MoveTo(OLDICurs.x+Left_width, OLDICurs.y+Header_Hight);
	pDC->LineTo(OLDICurs.x+Left_width, OLDFCurs.y+Header_Hight);
	pDC->LineTo(OLDFCurs.x+Left_width, OLDFCurs.y+Header_Hight);
	pDC->LineTo(OLDFCurs.x+Left_width, OLDICurs.y+Header_Hight);
	pDC->LineTo(OLDICurs.x+Left_width, OLDICurs.y+Header_Hight);
	// New
	if (redraw) {
		pDC->MoveTo(IPos.x+Left_width, IPos.y+Header_Hight);
		pDC->LineTo(IPos.x+Left_width, FPos.y+Header_Hight);
		pDC->LineTo(FPos.x+Left_width, FPos.y+Header_Hight);
		pDC->LineTo(FPos.x+Left_width, IPos.y+Header_Hight);
		pDC->LineTo(IPos.x+Left_width, IPos.y+Header_Hight);
		OLDICurs = IPos;
		OLDFCurs = FPos;
	}
	// Restore pen
	pDC->SelectObject(oldpen);
}

void Display_IMG::OnMouseMove(UINT nFlags, CPoint point) 
{	
	if (LMouseDown) {
		// Draw the rectangle
		if (ICurs.x < point.x && ICurs.y < point.y) {
			DrawSelectedRectangle(ICurs,  point, 1);
		}
	} 
	CDialog::OnMouseMove(nFlags, point);
}

void Display_IMG::OnLButtonUp(UINT nFlags, CPoint point) 
{
	DWORD r;
	FCurs.x = point.x;
	FCurs.y = point.y;
	LMouseDown = 0;
	// do the population of the windows by sending a message to the other dialog
	::SendMessageTimeout(HWND_BROADCAST, WM_NULL, 1, 0,0,10, &r);

	CDialog::OnLButtonDown(nFlags, point);
}

// Display_IMG message handlers
